hdu 1969 Pie 二分

来源:互联网 发布:塞班同步助手 网络错误 编辑:程序博客网 时间:2024/05/16 08:20

Pie

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 4513    Accepted Submission(s): 1819


Problem Description
My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size. 

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.
 

 

Input
One line with a positive integer: the number of test cases. Then for each test case:
---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.
---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.
 

 

Output
For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).
 

 

Sample Input
3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2
 

 

Sample Output
25.1327
3.1416
50.2655
 
题目大意:
生日聚会上,来到的所有朋友都会领取一块饼,但是要求的是所有人都要拿到大小相同的饼!题目要求输出的是:每个人尽量拿到的最大的饼的体积是多少?
题解:
 二分答案,把问题转换为是否可以让每个人获得x面积的派

注意精度和π的取值
#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>#include <queue>#include <vector>#include <cmath>#include <set>#include <map>using namespace std;const double pie=acos(-1.0);double a[10005];int n,f;bool ok(double x){    //记录份数    int cnt=0;    for(int i=0; i<n; i++)    {        cnt+=(int)(a[i]/x);//记得算派个数的时候向下取整    }    //判断是否可以切成f份    if(cnt<f) return false;    else return true;}int main(){    int t;    scanf("%d",&t);    while(t--)    {        scanf("%d%d",&n,&f);        f++;//因为主人也想要pie        //二分pie的面积        double l=0,r=0;        int x;        for(int i=0; i<n; i++)        {            scanf("%d",&x);            a[i]=x*x*pie;            r=max(r,a[i]);        }        while(r-l>1e-6)//精度选择        {            double mid=(l+r)/2;            if(ok(mid))                l=mid;            else                r=mid;        }        printf("%.4lf\n",l);    }    return 0;}



0 0
原创粉丝点击